// demo01.cc
//
//  LISTAREAS  LISTAREAS:regexp - 뢮  log p  
//  :
//
// JUST Here follows list of areas matching regexp "ADA":
// JUST SU.PASCAL.MODULA.ADA: Echomail Squish "e:\engine\jt\areas\D75EA00F"

Hook cwEarliest
 number re, K, Area, AreaFormat, Style, Format;
 string Path, Mask;
 {
  if not ListAreasPerform then
   Exit;

  if ListAreasMask = '' then
   Mask:='.*'
  else
   Mask:=ListAreasMask;

  StUpcaseEx(Mask);

  CompileRegExp(Mask, re, linkerStubSoft, False);

  if re = nil then
   {
    LogWrite('?', 'LISTAREAS: failed to compile regexp "' + Mask + '"');

    Exit;
   };

  AreaFormat:=NewAreaFormat;

  LogWrite('i', 'Here follows list of areas matching regexp "' + Mask + '":');

  for K:=0 to areaCount - 1 do
   if AreaMatchRegExp(re, areaGetName(areaAt(K))) then
    {
     Area:=areaAt(K);

     areaGetFormat(Area, AreaFormat);

     UnpackAreaFormat(AreaFormat, Style, Format, Path);

     LogWrite('i', pstos(areaGetName(Area)) + ': ' +
                   GetAreaStyleName(Style) + ' ' +
                   GetAreaFormatName(Format, True) + ' "' + Path + '"');
    };

  DestroyAreaFormat(AreaFormat);

  DestroyRegExp(re);
 };
