// demo03.cc
//
// MAKEAREAREAD:regexp, MAKEAREAUNREAD:regexp - ⠭ 䫠 p⠭
//   ᮮ饭  , 室  p; p p
// pp eachMsg  pp  ᮮ饭  

hook cwEarliest
 boolean Read, IsRead, Killed;
 number re, Area, mb, msg, No, TotalNo, Timer, GlobalMade, GlobalAreas, LocalMade;
 string Mask, Operation, AreaName, rc;
 {
  if not (MakeAreaReadPerform or MakeAreaUnreadPerform) then
   Exit;

  if MakeAreaReadPerform and MakeAreaUnreadPerform then
   {
    SetError('Both MAKEAREAREAD and MAKEAREAUNREAD switches shouldn''t be specified');

    Exit;
   };

  Read:=MakeAreaReadPerform;

  if Read then
   {
    Mask:=MakeAreaReadMask;

    Operation:='read';
   }
  else
   {
    Mask:=MakeAreaUnreadMask;

    Operation:='unread';
   };

  StUpcaseEx(Mask);

  CompileRegExp(Mask, re, linkerStubSoft, False);

  if re = nil then
   {
    LogWrite('?', 'MAKEAREA' + StUpcase(Operation) + ': failed to compile regexp "' + Mask + '"');

    Exit;
   };

  LogWrite('M', 'Making areas matching regexp "' + Mask + '" ' + Operation + ':');

  GlobalMade:=0;
  GlobalAreas:=0;

  eachArea(re, Area)
   if not areaPassthrough(Area) then
    {
     AreaName:=GetAreaName(Area);

     SetStatus(AreaName + ' opening');

     if not areaLock(Area, mb, rc) then
      {
       LogWrite('?', 'Failed to open ' + AreaName + ': ' + rc);

       Continue;
      };

     TotalNo:=mbCount(mb);

     Timer:=Clock - 100;

     Inc(GlobalAreas);

     LocalMade:=0;

     eachMsg(mb, msg, mfNone, No, Killed)
      {
       if Clock - Timer > 100 then
        {
         SetStatus(AreaName + ' ' + Percent(No, TotalNo) + ' setting ' + Operation);

         Timer:=Clock;
        };

       IsRead:=msgGetAttributes(msg) nand maRead <> 0;

       if IsRead <> Read then
        {
         if Read then
          msgSetAttributes(msg, msgGetAttributes(msg) nor maRead)
         else
          msgSetAttributes(msg, msgGetAttributes(msg) nand nnot maRead);

         if mbStore(mb, No, msg, rc, mfNone) then
          {
//           LogWrite('~', AreaName + ': msg#' + ntos(No) + ' made ' + Operation);

           Inc(LocalMade);
           Inc(GlobalMade);
          }
         else
          LogWrite('?', AreaName + ': failed to write msg ' + ntos(No) + ', ' + rc);
        };

       if Cancelled then
        Break;
      };

     SetStatus(AreaName + ' closing');

     areaUnlock(Area, mb);

     if LocalMade <> 0 then
      LogWrite('M', AreaName + ': ' + ntos(LocalMade) + ' msg' + _s(LocalMade) + ' made ' + Operation);

     if Cancelled then
      Break;
    };

  if GlobalAreas = 0 then
   LogWrite('M', 'Nothing to do.')
  else
   if GlobalMade = 0 then
    LogWrite('M', ntos(GlobalAreas) + ' area' + _s(GlobalAreas) +
                  ' scanned, no messages made ' + Operation)
   else
    if GlobalAreas > 1 then
     LogWrite('M', ntos(GlobalAreas) + ' area' + _s(GlobalAreas) +
                   ' scanned, ' + ntos(GlobalMade) + ' message' + _s(GlobalMade) +
                   ' made ' + Operation);

  DestroyRegExp(re);
 };

// 騩 p eachMsg:
//
// eachMsg(mb, msg, flags, no, killed) {  pp }
//
//  mb - 㪠⥫  p   areaLock  ᮮ饭,
//     msg - p,  p 㤥 ᠭ 㪠⥫  p
//      p㦥 ᮮ饭,
//     flags -  䫠 (mfXXX); mfNone - p㧨  ᮮ饭,
//      mfNoText - p㧨 ⮫쪮  ( ⥪ ᮮ饭)
//     no - p,  p 㤥 ᠭ p ⥪饣 ᮮ饭,
//     killed - p, p 㦭 ⠭  True, ᫨ 
//      㡨 ᮮ饭     mbKill.

// p p eachArea .  demo02.cc
//
// :
//
//   ( p 㪠뢠 pp p) p
//  100 ( p).  ⢫   㭪樨 Clock,
// p p頥 ⢮ ᥪ㭤, p襤 ᫥ 㭮
// ( DPMI-pᨨ)    p p ( W32/OS2-pᨨ).
//
// ⮢ p樨 p   㭪権 nand (  ⮬
// p  ᯮ), nor, nxor, nnot -  㤨 p䨪 "n" ;)
//
// ⠪  ᯮ 㭪 _s(number), p p頥 p
// "s" ᫨ p  ᫮ p  p    p
//   ⠫ :)
