// hla.cc, HardLinkAddressing(tm), HLA(tm)
//
//  p ⢫ pp 室 p   ᮮ饭,
// p室饣  , 饣  pp襭 HardLinkAddressing.
// ᫨ p  msgid  㤥 ᮮ⢥⢮ 室 p ,
// ᮮ饭 㤥 pᥭ  badmail  ᮮ⢥騬 㤦
//
//  p ⮣ p 室 稥 ᫥ p  autoexec.cc:
//
// number restHLA;
//
// Hook ccStartup
//  {
//   restHLA:=restsAdd('HardLinkAddressing', rsMinus);
//  };
//
// pp襭 ( ,  ,  pp襭   jt.ctl? :)
//
// Restriction <\.> <> HardLinkAddressing
//
// 砥 HLA   ⮢.

number hlaLinkAddress, hlaFromAddress;

hook cwStartup
 {
  hlaLinkAddress:=NewAddressEx(0, 0, 0, 0);
  hlaFromAddress:=NewAddressEx(0, 0, 0, 0);
 };

hook taMessageTossFilter
 number st, msgp;
 string Description;
 {
  st:=msgst(msg);

  if (stGet(st, 'Source') = tsBaseInbound) or (stGet(st, 'NoCallbacks') <> 0) or (Link = nil) then
   Exit;

  linkGetAddress(Link, hlaLinkAddress);

  if not restsCheck(restHLA, hlaLinkAddress, nil) then
   Exit;

  msgp:=msgCreateParser(msg, False);

  ClearAddress(hlaFromAddress);

  msgpGetFromAddress(msgp, hlaFromAddress);

  msgDestroyParser(msgp);

  if not AddressEqu(hlaLinkAddress, hlaFromAddress) then
   {
    Description:='expected msg address ' + AddressToStrEx(hlaLinkAddress) +
                                ', got ' + AddressToStrEx(hlaFromAddress);

    LogWrite('H', 'HLA: ' + Description);

    tossscanTossToBadmail(msg, Description + ' (HLA)');

    msg:=nil;
    Area:=nil;
   };
 };

hook cwShutdown
 {
  DestroyAddress(hlaFromAddress);
  DestroyAddress(hlaLinkAddress);
 };
