// rewrite.cc
//
// REWRITE[:regexp] - "pp㧨" ᮮ饭  , .. ᫥⥫쭮
// ⠥ ᮮ饭    p⭮.
//
// p, pp, p p室  1255  1256  p  jam':
//   ⮬,   mbjam.dll  1255  p쭮 p뢠
// crc32  @msgid  @reply,  1256  p  ⠭p  ᫥
// p室  1256 室  "jt rewrite:.*". rewrite
// ᫥⥫쭮 p ᮮ饭,  crc32  @msgid  @reply 
// .

hook cwEarliest
 string rc;
 procedure Perform(number Area, mb)
  number No, msg, Timer;
  {
   if not mbLock(mb) then
    {
     LogWrite('?', 'Failed to lock ' + GetAreaName(Area));

     Exit;
    };

   Timer:=0;

   for No:=0 to mbCount(mb) - 1 do
    {
     if Clock - Timer > 250 then
      {
       SetStatus(GetAreaName(Area) + ' rewriting ' + Percent(No, mbCount(mb)));

       Timer:=Clock;

       if Cancelled then
        Break;
      };

     if mbLoad(mb, No, msg, rc, mfNone) then
      {
       if not mbStore(mb, No, msg, rc, mfNone) then
        LogWrite('?', 'Failed to store msg ' + ntos(No) + ' in ' + GetAreaName(Area) + ': ' + rc);

       msgDestroy(msg);
      }
     else
      LogWrite('?', 'Failed to load msg ' + ntos(No) + ' from ' + GetAreaName(Area) + ': ' + rc);
    };

   mbUnlock(mb);
  };
 string Mask;
 number re, Area, mb;
 {
  if not RewritePerform then
   Exit;

  if RewriteMask = '' then
   Mask:='.*'
  else
   Mask:=RewriteMask;

  StUpcaseEx(Mask);

  CompileRegExp(Mask, re, linkerStubSoft, False);

  if re = nil then
   {
    LogWrite('?', 'REWRITE: failed to compile regexp "' + Mask + '"');

    Exit;
   };

  LogWrite('F', 'Rewriting messages in areas matching regexp "' + Mask + '"');

  eachArea(re, Area)
   if Cancelled then
    Break
   else
    if not areaPassthrough(Area) then
     {
      SetStatus(GetAreaName(Area) + ' opening');

      if areaLock(Area, mb, rc) then
       {
        Perform(Area, mb);

        areaUnlock(Area, mb);

        SetStatus(GetAreaName(Area) + ' closing');
       }
      else
       LogWrite('?', 'Failed to open ' + GetAreaName(Area) + ': ' + rc);
     };

  ClearStatus;

  DestroyRegExp(re);
 };

end
