// buns.cc
//
// 誨

number bunsEInMsgs, bunsEInSize;
number bunsEOutMsgs, bunsEOutSize;
number bunsEBaseMsgs, bunsEBaseSize;
number bunsTotalTime;
number bunsBMsgs, bunsBSize;
number bunsDMsgsMoved, bunsDMsgsKilled;
number bunsCMsgs;
number bunsTMsgs;
number bunsAreasCreated;

//  ⨯ cwBeforeToss 뢠 p ᪮ ᨭ.   
// 祬 p ᪠ ᨭ   㭪樨 Clock, p p頥
// ᢮ p  ᥪ㭤:

hook cwBeforeToss
 {
  bunsTotalTime:=Clock;
 };

//  ⨯ taMessageTossLast 뢠 p ᨭ ᮮ饭,  
//  Tosser p p msg, p ᨬp
// ᫮-㪠⥫  ᮮ饭, p  ᨬ   .  ⮬
// 㪥  㢥稬 稪 bunsEInMsgs  bunsEInSize:

hook taMessageTossLast
 {
  bunsEInMsgs:=bunsEInMsgs + 1;
  bunsEInSize:=bunsEInSize + msgSize(msg);
 };

//  ⨯ taAreaCreated 뢠 ᫥ ᮧ p 

hook taAreaCreatedFirst
 {
  bunsAreasCreated:=bunsAreasCreated + 1;
 };

//  ⨯ taMessageTossToLinkNoClone 뢠 p ᨭ ᮮ饭 
// . 㢥稢 稪 bunsEOutMsgs  bunsEOutSize:

hook taMessageTossToLinkNoClone
 {
  bunsEOutMsgs:=bunsEOutMsgs + 1;
  bunsEOutSize:=bunsEOutSize + msgSize(msg);
 };

//  ⨯ taMessageTossBaseLast 뢠 p ᨭ ᮮ饭  .
// 㢥稢 稪 bunsEBaseMsgs  bunsEBaseSize:

hook taMessageTossBaseLast
 {
  bunsEBaseMsgs:=bunsEBaseMsgs + 1;
  bunsEBaseSize:=bunsEBaseSize + msgSize(msg);
 };

//  ⨯ taBadMessageToss 뢠 p ᨭ ᮮ饭  badmail.
// 㢥稢 稪 bunsBMsgs  bunsBSize:

hook taBadMessageToss
 {
  bunsBMsgs:=bunsBMsgs + 1;
  bunsBSize:=bunsBSize + msgSize(msg);
 };

// 㪨 ⨯ dcaMoved  dcaKilled 뢠 㯮 (DupeChecker,
// dupechk.dll)  砥 pᥭ - ᮮ饭  badmail 
//  砥  㡨 ᮮ⢥⢥. 㢥稢 ᮮ⢥騥 稪
// bunsDMsgsMoved  bunsDMsgsKilled:

hook dcaMoved
 {
  bunsDMsgsMoved:=bunsDMsgsMoved + 1;
 };

hook dcaKilled
 {
  bunsDMsgsKilled:=bunsDMsgsKilled + 1;
 };

//  ⨯ cwAfterToss 뢠 ᫥ 砭 p ᨭ.
//    "쥬 "  뢥  p    ⨪:

hook cwAfterToss
 number bunsTotalMsgs, bunsTotalSize, bunsMsgSec, bunsKbSec;
 number TitleWidth;
 boolean Written;
 string s;
 procedure CheckWritten
  {
   if not Written then
    {
     LogWrite(Chr(254), '');

     Written:=True;
    };
  };
 {
  // TitleWidth ⠭ ,  p 㤥 p  
  // p ⨪ ('In', 'Out', etc)

  TitleWidth:=6;

  // p⠥ p, p  ᨭ.  bunsTotalTime 㤥 ᠭ
  // p  ᥪ㭤.

  bunsTotalTime:=(Clock - bunsTotalTime) / 1000;

  // ᫨ bunsTotalTime = 0 (ᨭ   :),  p᢮ 
  // ⮩ p,  ᫥⢨   訡   .

  if bunsTotalTime = 0 then // strange, yeah? :)
   bunsTotalTime:=1;

  // ⠥ 饥 ⢮ ᮮ饭 (In + Out + Base)   pp:

  bunsTotalMsgs:=bunsEInMsgs + bunsEOutMsgs + bunsEBaseMsgs;
  bunsTotalSize:=bunsEInSize + bunsEOutSize + bunsEBaseSize;

  // p Written 㪠뢠, 뫮  - 뢥  p  .
  // p㬠  ᯥ樠쭮  ⮣, ⮡ p ⨪  ᫥
  // ⨪     p ᠫ  p窠.

  Written:=False;

  // ᫨ 饥 ⢮ (In + Out + Base)  p ,  뢥  p
  // ⨪  ⨬ p䠬:

  if bunsTotalMsgs <> 0 then
   {
    // ᫨  㤥 p p窠 ⨪,  ᭠砫 襬
    //  p...

    CheckWritten;

    // p 㭪 LefPad(s, Width) ⢫  p s
    // p ᫥   Width.

    // Long2StrFmt(n) pp ᫮  p  pp: ᫮ 12345
    // 㤥 p⠢  "12,345", pp.

    // _s(n) p  p, ᫨ n = 1  's' ᫨ n  p 1.

    // Size2KB(n) pp ᫮ (ᨬp饥 pp)  p.
    // Size2KB(2252), pp, p p '2.2kb'.

    LogWrite('<', LeftPad('In', TitleWidth) + ': ' +
                  Long2StrFmt(bunsEInMsgs) + ' msg' + _s(bunsEInMsgs) + ', ' +
                  Size2KB(bunsEInSize));

    LogWrite('>', LeftPad('Out', TitleWidth) + ': ' +
                  Long2StrFmt(bunsEOutMsgs) + ' msg' + _s(bunsEOutMsgs) + ', ' +
                  Size2KB(bunsEOutSize));

    LogWrite('|', LeftPad('Base', TitleWidth) + ': ' +
                  Long2StrFmt(bunsEBaseMsgs) + ' msg' + _s(bunsEBaseMsgs) + ', ' +
                  Size2KB(bunsEBaseSize));

    LogWrite('|', LeftPad('Total', TitleWidth) + ': ' +
                  Long2StrFmt(bunsTotalMsgs) + ' msg' + _s(bunsTotalMsgs) + ', ' +
                  Size2KB(bunsTotalSize) + ', ' +
                  ntos(bunsTotalTime) + ' sec' + _s(bunsTotalTime) + ', ' +
                  Speed(bunsTotalMsgs, bunsTotalTime) + ' msgs/s, ' +
                  Speed(bunsTotalSize/1024, bunsTotalTime) + ' kb/s');
   };

  // ᫨  badmail -  (bunsBMsgs <> 0)...

  if bunsBMsgs <> 0 then
   {
    CheckWritten;

    LogWrite('|', LeftPad('Bad', TitleWidth) + ': ' +
                  Long2StrFmt(bunsBMsgs) + ' msg' + _s(bunsBMsgs) + ', ' +
                  Size2KB(bunsBSize));
   };

  // ᫨ 뫨 ...

  if bunsDMsgsMoved + bunsDMsgsKilled <> 0 then
   {
    if bunsDMsgsMoved <> 0 then
     s:=ntos(bunsDMsgsMoved) + ' msg' + _s(bunsDMsgsMoved) + ' moved'
    else
     s:='';

    if bunsDMsgsKilled <> 0 then
     {
      if s <> '' then
       s:=s + ', ';

      s:=s + ntos(bunsDMsgsKilled) + ' msg' + _s(bunsDMsgsKilled) + ' killed';
     };

    CheckWritten;

    LogWrite('|', LeftPad('Dupes', TitleWidth) + ': ' + s);
   };

  // ᫨ 뫨 ⪠p ᮮ饭...

  if bunsCMsgs <> 0 then
   {
    CheckWritten;

    LogWrite('|', LeftPad('Carbon', TitleWidth) + ': ' + ntos(bunsCMsgs) + ' msg' + _s(bunsCMsgs));
   };

  // ᫨ 뫨 ⢨⮢ ᮮ饭...

  if bunsTMsgs <> 0 then
   {
    CheckWritten;

    LogWrite('|', LeftPad('Twit', TitleWidth) + ': ' + ntos(bunsTMsgs) + ' msg' + _s(bunsTMsgs));
   };

  // ᫨  ᮧ    ...

  if bunsAreasCreated <> 0 then
   {
    CheckWritten;

    LogWrite('|', LeftPad('ACR', TitleWidth) + ': ' + ntos(bunsAreasCreated) + ' area' + _s(bunsAreasCreated));
   };

  // ᫨  뢮 ⨪  p,  p訬  ⮩ p:

  if Written then
   LogWrite(Chr(254), '');
 };
