// demo04.cc
//
// CREATEBASES  CREATEBASES:regexp - p뢠   
// p ( , ᫨ 稥  p 饭) , ⥬ ᠬ
// ᮧ   

Hook cwEarliest
 string Mask, rc;
 number mb, re, Area;
 {
  if not CreateBasesPerform then
   Exit;

  if CreateBasesMask = '' then
   Mask:='.*'
  else
   Mask:=CreateBasesMask;

  StUpcaseEx(Mask);

  CompileRegExp(Mask, re, linkerStubSoft, False);

  if re = nil then
   {
    LogWrite('?', 'CREATEBASES: failed to compile regexp "' + Mask + '"');

    Exit;
   };

  LogWrite('C', 'Creating bases of areas matching regexp "' + Mask + '"');

  eachArea(re, Area)
   if Cancelled then
    Break
   else
    if not areaPassthrough(Area) then
     {
      SetStatus(GetAreaName(Area));

      if areaLock(Area, mb, rc) then
       areaUnlock(Area, mb)
      else
       LogWrite('?', 'Failed to open ' + GetAreaName(Area) + ': ' + rc);
     };

  ClearStatus;

  DestroyRegExp(re);

  LogWrite('C', 'Peak of opened areas: ' + ntos(POA));
 };
