// demo05.cc
//
// FIXLASTREADS[:regexp] - p p  㪠 pᯮ :
//  ᫥ p⠭ ᮮ饭  ⠢ p 㪠뢠騬 
// 

hook cwLatest
 string rc;
 procedure Perform(number Area, mb)
  number No, Found, msg, PreviousLastRead;
  {
   if not mbLock(mb) then
    {
     LogWrite('?', 'Failed to lock ' + GetAreaName(Area));

     Exit;
    };

   if mbCount(mb) > 0 then
    {
     if not mbExtendedOpened(mb, eooGetLastRead, naddr(PreviousLastRead)) then
      PreviousLastRead:=0;

     SetStatus(GetAreaName(Area) + ' seeking last read message');

     Found:=-1;

     for No:=mbCount(mb) - 1 downto 0 do
      if mbLoad(mb, No, msg, rc, mfNone) then
       if msgGetAttributes(msg) nand maRead <> 0 then
        {
         Found:=No;

         msgDestroy(msg);

         Break;
        }
       else
        msgDestroy(msg);

     if Found = -1 then
      Found:=mbNoToGlobal(mb, 0) - 1
     else
      Found:=mbNoToGlobal(mb, Found) - 1;

     SetStatus(GetAreaName(Area) + ' setting lastread');

     if Found <> PreviousLastRead then
      if not mbExtendedOpened(mb, eooSetLastRead, naddr(Found)) then
       LogWrite('?', GetAreaName(Area) + ': failed to set lastread to ' + ntos(Found))
      else
       LogWrite('F', GetAreaName(Area) + ': lastread ' + ntos(Found) + ' (was ' + ntos(PreviousLastRead) + ')');
    };

   mbUnlock(mb);
  };
 string Mask;
 number re, Area, mb;
 {
  if not FixLastReadsPerform then
   Exit;

  if FixLastReadsMask = '' then
   Mask:='.*'
  else
   Mask:=FixLastReadsMask;

  StUpcaseEx(Mask);

  CompileRegExp(Mask, re, linkerStubSoft, False);

  if re = nil then
   {
    LogWrite('?', 'FIXLASTREADS: failed to compile regexp "' + Mask + '"');

    Exit;
   };

  LogWrite('F', 'Fixing lastreads of areas matching regexp "' + Mask + '"');

  eachArea(re, Area)
   if Cancelled then
    Break
   else
    if not areaPassthrough(Area) then
     {
      SetStatus(GetAreaName(Area) + ' opening');

      if areaLock(Area, mb, rc) then
       {
        Perform(Area, mb);

        areaUnlock(Area, mb);

        SetStatus(GetAreaName(Area) + ' closing');
       }
      else
       LogWrite('?', 'Failed to open ' + GetAreaName(Area) + ': ' + rc);
     };

  ClearStatus;

  DestroyRegExp(re);
 };
