; JT v1.1.1257, created at 17 Jan 17:31:47, configuration file
;
; general syntax:
;
; Address <address>
;  Aka <address>
;  InPassword "password"
;  OutPassword "password"
;  Archiver "archiver_id"
;  Mode "oml"
;
; use OMINFO commandline switch or documentation to obtain the information
; about supported outbound mode links
;
; link's subscribe looks like this:
;  Area flags "areaname"
;
; where flags - combination of R (readable), W (writeable), P (passive)
; or U (unsubscribed)
;
; AutoCreator switches:
;   AutoCreate Yes|No
;   AutoCreateFormat Squish "path"
;   AutoCreateMask "regexp"
;   AutoCreateSubscribe address "regexp"
;
; Areafix switch:
;   AreafixPassword "password"
;
; BCL switches:
;   AutoBCL Yes|No
;   AutoBCLLast unixtime
;   UpdateBCL Yes|No
;
; ForwardRequests switches:
;   ForwardRequests Yes|No
;   ForwardRequestList Echolist "fname"
;   ForwardRequestList AreaDesc "fname"
;   ForwardRequestList BCL
;   ForwardRequestTimeout days
;   ForwardRequestFormat Passthrough "path"
;
; Readonly switches:
;   ReadonlyAuto "area" dd/mm/yyyy
;   ReadonlyManual "area" dd/mm/yyyy
;
; RemoteLinkOperations switches:
;   RobotName "remote robot name"
;   RobotSubscribePrefix "subscribe prefix"
;   RobotUnsubscribePrefix "unsubscribe prefix"
;   RobotTearline Yes|No
;   RobotOrigin Yes|No
;
; Statistix switches:
;  LastTrafficIn UDT
;  LastTrafficOut UDT
;  TotalTrafficIn number
;  TotalTrafficOut number
;
; TossMap switch:
;   TossMap "external_name" "internal_name"
;
; TossPrio(tm) switch:
;   TossPrio "area_regexp" "oml"
;

Address 2:6033/2727
 Aka 2:6033/27
 InPassword "..."
 OutPassword "..."
 Archiver "ZIP"
 Mode "TBOX:ALWAYSNEWBUNDLE"
 AutoCreate Yes
   AutoCreateFormat Squish "E:\JTField\Areas\"
   AutoCreateSubscribe 2:6033/1 ".*"
   AutoCreateSubscribe 2:6033/2 "^RU.*"
   AutoCreateSubscribe 2:6033/3 "^SU.*"
 AreafixPassword "..."
 BCL "E:\Engine\JT\BCLs\b1fef08f.bcl"
 AutoBCL 7
   AutoBCLLast 3C40D121
 RobotPassword "Someshit"
 LastTrafficIn 3C470A82
 LastTrafficOut 3C461317
 TotalTrafficIn 2119386
 TotalTrafficOut 1118313
 TotalCountIn 655
 TotalCountOut 156
 Area RW "$CRACK$"
 Area RW "$CRACK$.TALKS"
 Area RW "1072.COMPNEWS.TALK"
 Area RW "BRAKE'S.MAILER.SUPPORT"
 Area RW "ENET.SYSOP"
 Area RW "FAR.SUPPORT"
 Area RW "FIDONET.HISTORY"
 Area RW "GUITAR.SONGS"
 Area RW "GUITAR.SONGS.FILTERED"
 Area RW "GUITAR.SONGS.TALK"
 Area RW "HUMOR.FILTERED"
 Area RW "IV.ECHO"
 Area RW "MO.CARS.AUDIO"
 Area RW "MO.ECHO"
 Area RW "MO.JOB"
 Area RW "MO.MAKE.MONEY"
 Area RW "MO.MITINKA"
 Area RW "MO.PHRASES"
 Area RW "MO.PHYSTECH"
 Area RW "MO.TV"
 Area RW "MP.LINK"
 Area RW "N5020.CRISIS"
 Area RW "N5020.FILES"
 Area RW "N5020.HUBS"
 Area RW "N5020.POINT.TALK"
 Area RW "N5020.SYSOP"
 Area RW "NICE.SOURCES"
 Area RW "POWER.LOCAL"
 Area RW "PSKOV.BAZAR"
 Area RW "PSKOV.COMP"
 Area RW "PSKOV.INTERNET"
 Area RW "PSKOV.PVT.FIDO.MARAZM"
 Area RW "PSKOV.TORMOZ"
 Area RW "PVT.CRACK"
 Area RW "PVT.EXCH.BLACK.LOG.TALK"
 Area RW "PVT.FLIRT"
 Area RW "PVT.GIRLS"
 Area RW "PVT.LAW"
 Area RW "PVT.NIICHAVO"
 Area RW "PVT.SOUND.PRO"
 Area RW "R50.COORD"
 Area RW "R50.SYSOP"
 Area RW "R50.SYSOP.INFO"
 Area RW "R50.SYSOP.TALK"
 Area RW "RAILROAD.HUMOR"
 Area RW "RAILROAD.LOCAL"
 Area RW "RAILROAD.STAT"
 Area RW "ROCKWELL.MODEM"
 Area RW "RU.ACAD"
 Area RW "RU.ALGORITHMS"
 Area RW "RU.ANECDOT"
 Area RW "RU.ANEKDOT"
 Area RW "RU.ANOMALIA"
 Area RW "RU.ANTENN"
 Area RW "RU.ANTI-ANTISEX"
 Area RW "RU.ANTI.ATS"
 Area RW "RU.AON"
 Area RW "RU.AUTOPILOT"
 Area RW "RU.BATTLETECH"
 Area RW "RU.BEER"
 Area RW "RU.CGI.PERL"
 Area RW "RU.CISCO"
 Area RW "RU.COMPUTER.HUMOR"
 Area RW "RU.COMPUTERRA"
 Area RW "RU.DELPHI"
 Area RW "RU.DELPHI.DB"
 Area RW "RU.DELPHI.MASTER"
 Area RW "RU.DJ.PC"
 Area RW "RU.DJATLOV"
 Area RW "RU.DREAM"
 Area RW "RU.DTP"
 Area RW "RU.ECHOPROCESSORS"
 Area RW "RU.FANTASY"
 Area RW "RU.FASTUUE"
 Area RW "RU.FASTUUE.TALK"
 Area RW "RU.FIDO.INTERNET"
 Area RW "RU.FIPS"
 Area RW "RU.FOXPRO"
 Area RW "RU.GAME.RPG"
 Area RW "RU.GOLDED"
 Area RW "RU.GOLOVOLOMKA"
 Area RW "RU.HACKER"
 Area RW "RU.HALYAVA"
 Area RW "RU.HIP-HOP"
 Area RW "RU.HTML.CHAINIK"
 Area RW "RU.ILLUSION"
 Area RW "RU.INTERNET"
 Area RW "RU.INTERNET.BUSINESS"
 Area RW "RU.INTERNET.CHAINIK"
 Area RW "RU.INTERNET.FILTERED"
 Area RW "RU.INTERNET.HALYAVA"
 Area RW "RU.INTERNET.SOFT"
 Area RW "RU.JAVA"
 Area RW "RU.KMAIL"
 Area RW "RU.LINUX"
 Area RW "RU.LINUX.CHAINIK"
 Area RW "RU.LIST.CITYCAT.FIN.CBRATE"
 Area RW "RU.LIST.CITYCAT.FUNNY.CREAMFIDO"
 Area RW "RU.LIST.CITYCAT.FUNNY.GAMES.SLY"
 Area RW "RU.LIST.CITYCAT.NEWS.EZHE"
 Area RW "RU.MAGIC"
 Area RW "RU.MIXED.ALCOHOL"
 Area RW "RU.MODEM"
 Area RW "RU.MODERATOR"
 Area RW "RU.MSACCESS"
 Area RW "RU.MTV"
 Area RW "RU.MUSIC.DRUM&BASS"
 Area RW "RU.NECROMANCERS.DOS.NAVIGATOR"
 Area RW "RU.NETHACK"
 Area RW "RU.NETWORKS"
 Area RW "RU.NEWS"
 Area RW "RU.NLP"
 Area RW "RU.OS.CMP"
 Area RW "RU.PAGERS"
 Area RW "RU.PASCAL"
 Area RW "RU.PASCAL.CHAINIK"
 Area RW "RU.PASCAL.SOURCES"
 Area RW "RU.PHREAKS"
 Area RW "RU.PICKUP"
 Area RW "RU.PICKUP.GURU"
 Area RW "RU.PICTURES.PSEVDO.GRAF"
 Area RW "RU.PRIKOL"
 Area RW "RU.PSYCHOLOGY"
 Area RW "RU.RAILWAYS"
 Area RW "RU.REGINA.SUPPORT"
 Area RW "RU.SEX"
 Area RW "RU.SEX.ADV"
 Area RW "RU.SEX.ADV.TALK"
 Area RW "RU.SEX.EXCHANGE"
 Area RW "RU.SEX.PICTURES.UUE"
 Area RW "RU.SEX.SUPPORT"
 Area RW "RU.SEX.WIN95"
 Area RW "RU.SFMAIL"
 Area RW "RU.SPELLING"
 Area RW "RU.SPORT.FOOTBALL"
 Area RW "RU.SUBWAY"
 Area RW "RU.TEENAGERS"
 Area RW "RU.TOBACCO"
 Area RW "RU.UFO"
 Area RW "RU.UFO.TALKS"
 Area RW "RU.UFO.THEORY"
 Area RW "RU.UNIX.BSD"
 Area RW "RU.UNIX.LINUX"
 Area RW "RU.USR"
 Area RW "RU.VIDEO"
 Area RW "RU.VIDEO.X_FILES"
 Area RW "RU.VP"
 Area RW "RU.WEAPON"
 Area RW "RU.WEBSITE"
 Area RW "RU.WINAMP"
 Area RW "RU.WINDOWS.2000"
 Area RW "RU.WINDOWS.NT"
 Area RW "RU.WINDOWS.NT.ADMIN"
 Area RW "RU.WINDOWS.NT.BETA"
 Area RW "RU.WINDOWS.NT.CHAINIK"
 Area RW "RU.WINDOWS.NT.FAQ"
 Area RW "SPB.ANTI.ATS"
 Area RW "SPB.FILES.MP3"
 Area RW "SPB.FREUD"
 Area RW "SPB.JOB"
 Area RW "SPB.SYSOP"
 Area RW "SPB.SYSOP.INFO"
 Area RW "SU.3DS.MAX"
 Area RW "SU.ADOBE.PHOTOSHOP"
 Area RW "SU.BOOKS"
 Area RW "SU.CHAINIK.FAQ"
 Area RW "SU.DBMS.CASE"
 Area RW "SU.DBMS.INTERBASE"
 Area RW "SU.DBMS.SQL"
 Area RW "SU.FOOTBALL.PROGNOZ"
 Area RW "SU.GAME.NEWS"
 Area RW "SU.HAMRADIO"
 Area RW "SU.HARDW"
 Area RW "SU.HARDW.AUDIO"
 Area RW "SU.HARDW.CDROM"
 Area RW "SU.HARDW.CHAINIK"
 Area RW "SU.HARDW.HDD.REPAIR"
 Area RW "SU.HARDW.OTHER"
 Area RW "SU.HARDW.PC.CPU"
 Area RW "SU.HARDW.PC.MEDIA"
 Area RW "SU.HARDW.PC.MOTHERBOARD"
 Area RW "SU.HARDW.PC.PERIPHERAL"
 Area RW "SU.HARDW.PC.SOUND"
 Area RW "SU.HARDW.PC.VIDEO"
 Area RW "SU.HARDW.PC.VIDEO.CARD"
 Area RW "SU.HARDW.PC.VIDEO.MONITOR"
 Area RW "SU.HARDW.PC.VIDEO.RIVA"
 Area RW "SU.HARDW.SCHEMES"
 Area RW "SU.HARDW.TV.VIDEO"
 Area RW "SU.HARDW.TV.VIDEO.PROFI"
 Area RW "SU.HUMOR"
 Area RW "SU.IP.SYSOP"
 Area RW "SU.KASCHENKO.LOCAL"
 Area RW "SU.MUSIC.CREATION"
 Area RW "SU.MUSIC.DRUMS"
 Area RW "SU.MUSIC.LYRICS"
 Area RW "SU.MUSIC.RAP"
 Area RW "SU.OS2"
 Area RW "SU.PASCAL.MODULA.ADA"
 Area RW "SU.POL"
 Area RW "SU.SPY"
 Area RW "SU.VIRUS"
 Area RW "T-MAIL.RU"
 Area RW "TALKS.ASM"
 Area RW "XPEHOBO.MHE"
 Area RW "XSU.USELESS.FAQ"
 Area RW "Y.KPATKOE"

Address 2:6033/27.666
 Aka 2:6033/27
 InPassword "..."
 OutPassword "..."
 Archiver "ZIP"
 Mode "TBOX:ALWAYSNEWBUNDLE"
 AutoCreate Yes
   AutoCreateFormat Squish "E:\JTField\Areas\"
 AreafixPassword "..."
 BCL "E:\Engine\JT\BCLs\12345678.bcl"
 RobotPassword "Someshit"
 LastTrafficOut 3C470A83
 TotalTrafficOut 3242129
 TotalCountOut 813
 Area RW "$CRACK$"
 Area RW "$CRACK$.TALKS"
 Area RW "1072.COMPNEWS.TALK"
 Area RW "BRAKE'S.MAILER.SUPPORT"
 Area RW "ENET.SYSOP"
 Area RW "FAR.SUPPORT"
 Area RW "FIDONET.HISTORY"
 Area RW "GUITAR.SONGS"
 Area RW "GUITAR.SONGS.FILTERED"
 Area RW "GUITAR.SONGS.TALK"
 Area RW "HUMOR.FILTERED"
 Area RW "IV.ECHO"
 Area RW "MO.CARS.AUDIO"
 Area RW "MO.ECHO"
 Area RW "MO.JOB"
 Area RW "MO.MAKE.MONEY"
 Area RW "MO.MITINKA"
 Area RW "MO.PHRASES"
 Area RW "MO.PHYSTECH"
 Area RW "MP.LINK"
 Area RW "N5020.CRISIS"
 Area RW "N5020.FILES"
 Area RW "N5020.HUBS"
 Area RW "N5020.POINT.TALK"
 Area RW "N5020.SYSOP"
 Area RW "NICE.SOURCES"
 Area RW "POWER.LOCAL"
 Area RW "PSKOV.BAZAR"
 Area RW "PSKOV.COMP"
 Area RW "PSKOV.INTERNET"
 Area RW "PSKOV.PVT.FIDO.MARAZM"
 Area RW "PSKOV.TORMOZ"
 Area RW "PVT.CRACK"
 Area RW "PVT.EXCH.BLACK.LOG.TALK"
 Area RW "PVT.FLIRT"
 Area RW "PVT.GIRLS"
 Area RW "PVT.LAW"
 Area RW "PVT.NIICHAVO"
 Area RW "PVT.SOUND.PRO"
 Area RW "R50.COORD"
 Area RW "R50.SYSOP"
 Area RW "R50.SYSOP.INFO"
 Area RW "R50.SYSOP.TALK"
 Area RW "RAILROAD.HUMOR"
 Area RW "RAILROAD.LOCAL"
 Area RW "RAILROAD.STAT"
 Area RW "ROCKWELL.MODEM"
 Area RW "RU.ACAD"
 Area RW "RU.ALGORITHMS"
 Area RW "RU.ANECDOT"
 Area RW "RU.ANOMALIA"
 Area RW "RU.ANTI-ANTISEX"
 Area RW "RU.ANTI.ATS"
 Area RW "RU.AON"
 Area RW "RU.AUTOPILOT"
 Area RW "RU.BATTLETECH"
 Area RW "RU.BEER"
 Area RW "RU.CGI.PERL"
 Area RW "RU.CISCO"
 Area RW "RU.COMPUTER.HUMOR"
 Area RW "RU.DELPHI"
 Area RW "RU.DELPHI.DB"
 Area RW "RU.DELPHI.MASTER"
 Area RW "RU.DREAM"
 Area RW "RU.DTP"
 Area RW "RU.ECHOPROCESSORS"
 Area RW "RU.FANTASY"
 Area RW "RU.FASTUUE"
 Area RW "RU.FASTUUE.TALK"
 Area RW "RU.FIDO.INTERNET"
 Area RW "RU.FIPS"
 Area RW "RU.FOXPRO"
 Area RW "RU.GAME.RPG"
 Area RW "RU.GOLDED"
 Area RW "RU.GOLOVOLOMKA"
 Area RW "RU.HACKER"
 Area RW "RU.HIP-HOP"
 Area RW "RU.HTML.CHAINIK"
 Area RW "RU.ILLUSION"
 Area RW "RU.INTERNET"
 Area RW "RU.INTERNET.BUSINESS"
 Area RW "RU.INTERNET.CHAINIK"
 Area RW "RU.INTERNET.FILTERED"
 Area RW "RU.INTERNET.HALYAVA"
 Area RW "RU.INTERNET.SOFT"
 Area RW "RU.KMAIL"
 Area RW "RU.LINUX"
 Area RW "RU.LINUX.CHAINIK"
 Area RW "RU.LIST.CITYCAT.FIN.CBRATE"
 Area RW "RU.LIST.CITYCAT.FUNNY.CREAMFIDO"
 Area RW "RU.LIST.CITYCAT.FUNNY.GAMES.SLY"
 Area RW "RU.LIST.CITYCAT.NEWS.EZHE"
 Area RW "RU.MIXED.ALCOHOL"
 Area RW "RU.MODEM"
 Area RW "RU.MODERATOR"
 Area RW "RU.MSACCESS"
 Area RW "RU.MTV"
 Area RW "RU.MUSIC.DRUM&BASS"
 Area RW "RU.NECROMANCERS.DOS.NAVIGATOR"
 Area RW "RU.NETHACK"
 Area RW "RU.NETWORKS"
 Area RW "RU.NEWS"
 Area RW "RU.NLP"
 Area RW "RU.OS.CMP"
 Area RW "RU.PAGERS"
 Area RW "RU.PASCAL"
 Area RW "RU.PASCAL.CHAINIK"
 Area RW "RU.PASCAL.SOURCES"
 Area RW "RU.PHREAKS"
 Area RW "RU.PICKUP"
 Area RW "RU.PICKUP.GURU"
 Area RW "RU.PICTURES.PSEVDO.GRAF"
 Area RW "RU.PRIKOL"
 Area RW "RU.PSYCHOLOGY"
 Area RW "RU.RAILWAYS"
 Area RW "RU.REGINA.SUPPORT"
 Area RW "RU.SEX"
 Area RW "RU.SEX.ADV"
 Area RW "RU.SEX.ADV.TALK"
 Area RW "RU.SEX.EXCHANGE"
 Area RW "RU.SEX.PICTURES.UUE"
 Area RW "RU.SEX.SUPPORT"
 Area RW "RU.SEX.WIN95"
 Area RW "RU.SFMAIL"
 Area RW "RU.SPELLING"
 Area RW "RU.SPORT.FOOTBALL"
 Area RW "RU.SUBWAY"
 Area RW "RU.TEENAGERS"
 Area RW "RU.TOBACCO"
 Area RW "RU.UFO"
 Area RW "RU.UFO.TALKS"
 Area RW "RU.UFO.THEORY"
 Area RW "RU.UNIX.LINUX"
 Area RW "RU.USR"
 Area RW "RU.VIDEO"
 Area RW "RU.VIDEO.X_FILES"
 Area RW "RU.VP"
 Area RW "RU.WEBSITE"
 Area RW "RU.WINAMP"
 Area RW "RU.WINDOWS.2000"
 Area RW "RU.WINDOWS.NT"
 Area RW "RU.WINDOWS.NT.ADMIN"
 Area RW "RU.WINDOWS.NT.BETA"
 Area RW "RU.WINDOWS.NT.CHAINIK"
 Area RW "RU.WINDOWS.NT.FAQ"
 Area RW "SPB.ANTI.ATS"
 Area RW "SPB.FILES.MP3"
 Area RW "SPB.FREUD"
 Area RW "SPB.JOB"
 Area RW "SPB.SYSOP"
 Area RW "SPB.SYSOP.INFO"
 Area RW "SU.3DS.MAX"
 Area RW "SU.ADOBE.PHOTOSHOP"
 Area RW "SU.BOOKS"
 Area RW "SU.DBMS.INTERBASE"
 Area RW "SU.FOOTBALL.PROGNOZ"
 Area RW "SU.GAME.NEWS"
 Area RW "SU.HAMRADIO"
 Area RW "SU.HARDW"
 Area RW "SU.HARDW.AUDIO"
 Area RW "SU.HARDW.CDROM"
 Area RW "SU.HARDW.CHAINIK"
 Area RW "SU.HARDW.HDD.REPAIR"
 Area RW "SU.HARDW.OTHER"
 Area RW "SU.HARDW.PC.CPU"
 Area RW "SU.HARDW.PC.MEDIA"
 Area RW "SU.HARDW.PC.MOTHERBOARD"
 Area RW "SU.HARDW.PC.PERIPHERAL"
 Area RW "SU.HARDW.PC.SOUND"
 Area RW "SU.HARDW.PC.VIDEO"
 Area RW "SU.HARDW.PC.VIDEO.CARD"
 Area RW "SU.HARDW.PC.VIDEO.MONITOR"
 Area RW "SU.HARDW.PC.VIDEO.RIVA"
 Area RW "SU.HARDW.SCHEMES"
 Area RW "SU.HARDW.TV.VIDEO"
 Area RW "SU.HARDW.TV.VIDEO.PROFI"
 Area RW "SU.HUMOR"
 Area RW "SU.IP.SYSOP"
 Area RW "SU.MUSIC.DRUMS"
 Area RW "SU.MUSIC.LYRICS"
 Area RW "SU.MUSIC.RAP"
 Area RW "SU.OS2"
 Area RW "SU.POL"
 Area RW "SU.SPY"
 Area RW "SU.VIRUS"
 Area RW "T-MAIL.RU"
 Area RW "TALKS.ASM"
 Area RW "XPEHOBO.MHE"
 Area RW "XSU.USELESS.FAQ"

Address 2:6033/1
 Aka 2:6033/27
 InPassword "asd"
 OutPassword "asd"
 Archiver "ZIP"
 Mode "TBOX:ALWAYSNEWBUNDLE"
 AreafixPassword "stuff"
 BCL "E:\Engine\JT\BCLs\b5a10e43.bcl"
 RobotPassword "anothershit"
 LastTrafficOut 3C470A83
 TotalTrafficOut 3232643
 TotalCountOut 811
 Area RW "$CRACK$"
 Area RW "$CRACK$.TALKS"
 Area RW "1072.COMPNEWS.TALK"
 Area RW "BRAKE'S.MAILER.SUPPORT"
 Area RW "ENET.SYSOP"
 Area RW "FAR.SUPPORT"
 Area RW "FIDONET.HISTORY"
 Area RW "GUITAR.SONGS"
 Area RW "GUITAR.SONGS.FILTERED"
 Area RW "GUITAR.SONGS.TALK"
 Area RW "HUMOR.FILTERED"
 Area RW "IV.ECHO"
 Area RW "MO.CARS.AUDIO"
 Area RW "MO.ECHO"
 Area RW "MO.JOB"
 Area RW "MO.MAKE.MONEY"
 Area RW "MO.MITINKA"
 Area RW "MO.PHRASES"
 Area RW "MO.PHYSTECH"
 Area RW "MO.TV"
 Area RW "MP.LINK"
 Area RW "N5020.CRISIS"
 Area RW "N5020.FILES"
 Area RW "N5020.HUBS"
 Area RW "N5020.POINT.TALK"
 Area RW "N5020.SYSOP"
 Area RW "NICE.SOURCES"
 Area RW "POWER.LOCAL"
 Area RW "PSKOV.BAZAR"
 Area RW "PSKOV.COMP"
 Area RW "PSKOV.INTERNET"
 Area RW "PSKOV.PVT.FIDO.MARAZM"
 Area RW "PSKOV.TORMOZ"
 Area RW "PVT.CRACK"
 Area RW "PVT.EXCH.BLACK.LOG.TALK"
 Area RW "PVT.FLIRT"
 Area RW "PVT.GIRLS"
 Area RW "PVT.LAW"
 Area RW "PVT.NIICHAVO"
 Area RW "PVT.SOUND.PRO"
 Area RW "R50.COORD"
 Area RW "R50.SYSOP"
 Area RW "R50.SYSOP.INFO"
 Area RW "R50.SYSOP.TALK"
 Area RW "RAILROAD.HUMOR"
 Area RW "RAILROAD.LOCAL"
 Area RW "RAILROAD.STAT"
 Area RW "ROCKWELL.MODEM"
 Area RW "RU.ACAD"
 Area RW "RU.ALGORITHMS"
 Area RW "RU.ANECDOT"
 Area RW "RU.ANEKDOT"
 Area RW "RU.ANOMALIA"
 Area RW "RU.ANTENN"
 Area RW "RU.ANTI-ANTISEX"
 Area RW "RU.ANTI.ATS"
 Area RW "RU.AON"
 Area RW "RU.AUTOPILOT"
 Area RW "RU.BATTLETECH"
 Area RW "RU.BEER"
 Area RW "RU.CGI.PERL"
 Area RW "RU.CISCO"
 Area RW "RU.COMPUTER.HUMOR"
 Area RW "RU.COMPUTERRA"
 Area RW "RU.DELPHI"
 Area RW "RU.DELPHI.DB"
 Area RW "RU.DELPHI.MASTER"
 Area RW "RU.DJ.PC"
 Area RW "RU.DJATLOV"
 Area RW "RU.DREAM"
 Area RW "RU.DTP"
 Area RW "RU.ECHOPROCESSORS"
 Area RW "RU.FANTASY"
 Area RW "RU.FASTUUE"
 Area RW "RU.FASTUUE.TALK"
 Area RW "RU.FIDO.INTERNET"
 Area RW "RU.FIPS"
 Area RW "RU.FOXPRO"
 Area RW "RU.GAME.RPG"
 Area RW "RU.GOLDED"
 Area RW "RU.GOLOVOLOMKA"
 Area RW "RU.HACKER"
 Area RW "RU.HALYAVA"
 Area RW "RU.HIP-HOP"
 Area RW "RU.HTML.CHAINIK"
 Area RW "RU.ILLUSION"
 Area RW "RU.INTERNET"
 Area RW "RU.INTERNET.BUSINESS"
 Area RW "RU.INTERNET.CHAINIK"
 Area RW "RU.INTERNET.FILTERED"
 Area RW "RU.INTERNET.HALYAVA"
 Area RW "RU.INTERNET.SOFT"
 Area RW "RU.JAVA"
 Area RW "RU.KMAIL"
 Area RW "RU.LINUX"
 Area RW "RU.LINUX.CHAINIK"
 Area RW "RU.LIST.CITYCAT.FIN.CBRATE"
 Area RW "RU.LIST.CITYCAT.FUNNY.CREAMFIDO"
 Area RW "RU.LIST.CITYCAT.FUNNY.GAMES.SLY"
 Area RW "RU.LIST.CITYCAT.NEWS.EZHE"
 Area RW "RU.MAGIC"
 Area RW "RU.MIXED.ALCOHOL"
 Area RW "RU.MODEM"
 Area RW "RU.MODERATOR"
 Area RW "RU.MSACCESS"
 Area RW "RU.MTV"
 Area RW "RU.MUSIC.DRUM&BASS"
 Area RW "RU.NECROMANCERS.DOS.NAVIGATOR"
 Area RW "RU.NETHACK"
 Area RW "RU.NETWORKS"
 Area RW "RU.NEWS"
 Area RW "RU.NLP"
 Area RW "RU.OS.CMP"
 Area RW "RU.PAGERS"
 Area RW "RU.PASCAL"
 Area RW "RU.PASCAL.CHAINIK"
 Area RW "RU.PASCAL.SOURCES"
 Area RW "RU.PHREAKS"
 Area RW "RU.PICKUP"
 Area RW "RU.PICKUP.GURU"
 Area RW "RU.PICTURES.PSEVDO.GRAF"
 Area RW "RU.PRIKOL"
 Area RW "RU.PSYCHOLOGY"
 Area RW "RU.RAILWAYS"
 Area RW "RU.REGINA.SUPPORT"
 Area RW "RU.SEX"
 Area RW "RU.SEX.ADV"
 Area RW "RU.SEX.ADV.TALK"
 Area RW "RU.SEX.EXCHANGE"
 Area RW "RU.SEX.PICTURES.UUE"
 Area RW "RU.SEX.SUPPORT"
 Area RW "RU.SEX.WIN95"
 Area RW "RU.SFMAIL"
 Area RW "RU.SPELLING"
 Area RW "RU.SPORT.FOOTBALL"
 Area RW "RU.SUBWAY"
 Area RW "RU.TEENAGERS"
 Area RW "RU.TOBACCO"
 Area RW "RU.UFO"
 Area RW "RU.UFO.TALKS"
 Area RW "RU.UFO.THEORY"
 Area RW "RU.UNIX.BSD"
 Area RW "RU.UNIX.LINUX"
 Area RW "RU.USR"
 Area RW "RU.VIDEO"
 Area RW "RU.VIDEO.X_FILES"
 Area RW "RU.VP"
 Area RW "RU.WEAPON"
 Area RW "RU.WEBSITE"
 Area RW "RU.WINAMP"
 Area RW "RU.WINDOWS.2000"
 Area RW "RU.WINDOWS.NT"
 Area RW "RU.WINDOWS.NT.ADMIN"
 Area RW "RU.WINDOWS.NT.BETA"
 Area RW "RU.WINDOWS.NT.CHAINIK"
 Area RW "RU.WINDOWS.NT.FAQ"
 Area RW "SPB.ANTI.ATS"
 Area RW "SPB.FILES.MP3"
 Area RW "SPB.FREUD"
 Area RW "SPB.JOB"
 Area RW "SPB.SYSOP"
 Area RW "SPB.SYSOP.INFO"
 Area RW "SU.3DS.MAX"
 Area RW "SU.ADOBE.PHOTOSHOP"
 Area RW "SU.BOOKS"
 Area RW "SU.CHAINIK.FAQ"
 Area RW "SU.DBMS.CASE"
 Area RW "SU.DBMS.INTERBASE"
 Area RW "SU.DBMS.SQL"
 Area RW "SU.FOOTBALL.PROGNOZ"
 Area RW "SU.GAME.NEWS"
 Area RW "SU.HAMRADIO"
 Area RW "SU.HARDW"
 Area RW "SU.HARDW.AUDIO"
 Area RW "SU.HARDW.CDROM"
 Area RW "SU.HARDW.CHAINIK"
 Area RW "SU.HARDW.HDD.REPAIR"
 Area RW "SU.HARDW.OTHER"
 Area RW "SU.HARDW.PC.CPU"
 Area RW "SU.HARDW.PC.MEDIA"
 Area RW "SU.HARDW.PC.MOTHERBOARD"
 Area RW "SU.HARDW.PC.PERIPHERAL"
 Area RW "SU.HARDW.PC.SOUND"
 Area RW "SU.HARDW.PC.VIDEO"
 Area RW "SU.HARDW.PC.VIDEO.CARD"
 Area RW "SU.HARDW.PC.VIDEO.MONITOR"
 Area RW "SU.HARDW.PC.VIDEO.RIVA"
 Area RW "SU.HARDW.SCHEMES"
 Area RW "SU.HARDW.TV.VIDEO"
 Area RW "SU.HARDW.TV.VIDEO.PROFI"
 Area RW "SU.HUMOR"
 Area RW "SU.IP.SYSOP"
 Area RW "SU.KASCHENKO.LOCAL"
 Area RW "SU.MUSIC.CREATION"
 Area RW "SU.MUSIC.DRUMS"
 Area RW "SU.MUSIC.LYRICS"
 Area RW "SU.MUSIC.RAP"
 Area RW "SU.OS2"
 Area RW "SU.PASCAL.MODULA.ADA"
 Area RW "SU.POL"
 Area RW "SU.SPY"
 Area RW "SU.VIRUS"
 Area RW "T-MAIL.RU"
 Area RW "TALKS.ASM"
 Area RW "XPEHOBO.MHE"
 Area RW "XSU.USELESS.FAQ"
 Area RW "Y.KPATKOE"

Address 2:6033/2
 Aka 2:6033/27
 InPassword "asd"
 OutPassword "asd"
 Archiver "ZIP"
 Mode "TBOX:ALWAYSNEWBUNDLE"
 AreafixPassword "stuff"
 RobotPassword "anothershit"
 RobotTearline Yes
 LastTrafficOut 3C470A83
 TotalTrafficOut 3241009
 TotalCountOut 811
 Area RW "$CRACK$"
 Area RW "$CRACK$.TALKS"
 Area RW "1072.COMPNEWS.TALK"
 Area RW "BRAKE'S.MAILER.SUPPORT"
 Area RW "ENET.SYSOP"
 Area RW "FAR.SUPPORT"
 Area RW "FIDONET.HISTORY"
 Area RW "GUITAR.SONGS"
 Area RW "GUITAR.SONGS.FILTERED"
 Area RW "GUITAR.SONGS.TALK"
 Area RW "HUMOR.FILTERED"
 Area RW "IV.ECHO"
 Area RW "MO.CARS.AUDIO"
 Area RW "MO.ECHO"
 Area RW "MO.JOB"
 Area RW "MO.MAKE.MONEY"
 Area RW "MO.MITINKA"
 Area RW "MO.PHRASES"
 Area RW "MO.PHYSTECH"
 Area RW "MP.LINK"
 Area RW "N5020.CRISIS"
 Area RW "N5020.FILES"
 Area RW "N5020.HUBS"
 Area RW "N5020.POINT.TALK"
 Area RW "N5020.SYSOP"
 Area RW "NICE.SOURCES"
 Area RW "POWER.LOCAL"
 Area RW "PSKOV.BAZAR"
 Area RW "PSKOV.COMP"
 Area RW "PSKOV.INTERNET"
 Area RW "PSKOV.PVT.FIDO.MARAZM"
 Area RW "PSKOV.TORMOZ"
 Area RW "PVT.CRACK"
 Area RW "PVT.EXCH.BLACK.LOG.TALK"
 Area RW "PVT.FLIRT"
 Area RW "PVT.GIRLS"
 Area RW "PVT.LAW"
 Area RW "PVT.NIICHAVO"
 Area RW "PVT.SOUND.PRO"
 Area RW "R50.COORD"
 Area RW "R50.SYSOP"
 Area RW "R50.SYSOP.INFO"
 Area RW "R50.SYSOP.TALK"
 Area RW "RAILROAD.HUMOR"
 Area RW "RAILROAD.LOCAL"
 Area RW "RAILROAD.STAT"
 Area RW "ROCKWELL.MODEM"
 Area RW "RU.ACAD"
 Area RW "RU.ALGORITHMS"
 Area RW "RU.ANECDOT"
 Area RW "RU.ANEKDOT"
 Area RW "RU.ANOMALIA"
 Area RW "RU.ANTENN"
 Area RW "RU.ANTI-ANTISEX"
 Area RW "RU.ANTI.ATS"
 Area RW "RU.AON"
 Area RW "RU.AUTOPILOT"
 Area RW "RU.BATTLETECH"
 Area RW "RU.BEER"
 Area RW "RU.CGI.PERL"
 Area RW "RU.CISCO"
 Area RW "RU.COMPUTER.HUMOR"
 Area RW "RU.COMPUTERRA"
 Area RW "RU.DELPHI"
 Area RW "RU.DELPHI.DB"
 Area RW "RU.DELPHI.MASTER"
 Area RW "RU.DJ.PC"
 Area RW "RU.DJATLOV"
 Area RW "RU.DREAM"
 Area RW "RU.DTP"
 Area RW "RU.ECHOPROCESSORS"
 Area RW "RU.FANTASY"
 Area RW "RU.FASTUUE"
 Area RW "RU.FASTUUE.TALK"
 Area RW "RU.FIDO.INTERNET"
 Area RW "RU.FIPS"
 Area RW "RU.FOXPRO"
 Area RW "RU.GAME.RPG"
 Area RW "RU.GOLDED"
 Area RW "RU.GOLOVOLOMKA"
 Area RW "RU.HACKER"
 Area RW "RU.HALYAVA"
 Area RW "RU.HIP-HOP"
 Area RW "RU.HTML.CHAINIK"
 Area RW "RU.ILLUSION"
 Area RW "RU.INTERNET"
 Area RW "RU.INTERNET.BUSINESS"
 Area RW "RU.INTERNET.CHAINIK"
 Area RW "RU.INTERNET.FILTERED"
 Area RW "RU.INTERNET.HALYAVA"
 Area RW "RU.INTERNET.SOFT"
 Area RW "RU.JAVA"
 Area RW "RU.KMAIL"
 Area RW "RU.LINUX"
 Area RW "RU.LINUX.CHAINIK"
 Area RW "RU.LIST.CITYCAT.FIN.CBRATE"
 Area RW "RU.LIST.CITYCAT.FUNNY.CREAMFIDO"
 Area RW "RU.LIST.CITYCAT.FUNNY.GAMES.SLY"
 Area RW "RU.LIST.CITYCAT.NEWS.EZHE"
 Area RW "RU.MAGIC"
 Area RW "RU.MIXED.ALCOHOL"
 Area RW "RU.MODEM"
 Area RW "RU.MODERATOR"
 Area RW "RU.MSACCESS"
 Area RW "RU.MTV"
 Area RW "RU.MUSIC.DRUM&BASS"
 Area RW "RU.NECROMANCERS.DOS.NAVIGATOR"
 Area RW "RU.NETHACK"
 Area RW "RU.NETWORKS"
 Area RW "RU.NEWS"
 Area RW "RU.NLP"
 Area RW "RU.OS.CMP"
 Area RW "RU.PAGERS"
 Area RW "RU.PASCAL"
 Area RW "RU.PASCAL.CHAINIK"
 Area RW "RU.PASCAL.SOURCES"
 Area RW "RU.PHREAKS"
 Area RW "RU.PICKUP"
 Area RW "RU.PICKUP.GURU"
 Area RW "RU.PICTURES.PSEVDO.GRAF"
 Area RW "RU.PRIKOL"
 Area RW "RU.PSYCHOLOGY"
 Area RW "RU.RAILWAYS"
 Area RW "RU.REGINA.SUPPORT"
 Area RW "RU.SEX"
 Area RW "RU.SEX.ADV"
 Area RW "RU.SEX.ADV.TALK"
 Area RW "RU.SEX.EXCHANGE"
 Area RW "RU.SEX.PICTURES.UUE"
 Area RW "RU.SEX.SUPPORT"
 Area RW "RU.SEX.WIN95"
 Area RW "RU.SFMAIL"
 Area RW "RU.SPELLING"
 Area RW "RU.SPORT.FOOTBALL"
 Area RW "RU.SUBWAY"
 Area RW "RU.TEENAGERS"
 Area RW "RU.TOBACCO"
 Area RW "RU.UFO"
 Area RW "RU.UFO.TALKS"
 Area RW "RU.UFO.THEORY"
 Area RW "RU.UNIX.BSD"
 Area RW "RU.UNIX.LINUX"
 Area RW "RU.USR"
 Area RW "RU.VIDEO"
 Area RW "RU.VIDEO.X_FILES"
 Area RW "RU.VP"
 Area RW "RU.WEAPON"
 Area RW "RU.WEBSITE"
 Area RW "RU.WINAMP"
 Area RW "RU.WINDOWS.2000"
 Area RW "RU.WINDOWS.NT"
 Area RW "RU.WINDOWS.NT.ADMIN"
 Area RW "RU.WINDOWS.NT.BETA"
 Area RW "RU.WINDOWS.NT.CHAINIK"
 Area RW "RU.WINDOWS.NT.FAQ"
 Area RW "SPB.ANTI.ATS"
 Area RW "SPB.FILES.MP3"
 Area RW "SPB.FREUD"
 Area RW "SPB.JOB"
 Area RW "SPB.SYSOP"
 Area RW "SPB.SYSOP.INFO"
 Area RW "SU.3DS.MAX"
 Area RW "SU.ADOBE.PHOTOSHOP"
 Area RW "SU.BOOKS"
 Area RW "SU.DBMS.INTERBASE"
 Area RW "SU.FOOTBALL.PROGNOZ"
 Area RW "SU.GAME.NEWS"
 Area RW "SU.HAMRADIO"
 Area RW "SU.HARDW"
 Area RW "SU.HARDW.AUDIO"
 Area RW "SU.HARDW.CDROM"
 Area RW "SU.HARDW.CHAINIK"
 Area RW "SU.HARDW.HDD.REPAIR"
 Area RW "SU.HARDW.OTHER"
 Area RW "SU.HARDW.PC.CPU"
 Area RW "SU.HARDW.PC.MEDIA"
 Area RW "SU.HARDW.PC.MOTHERBOARD"
 Area RW "SU.HARDW.PC.PERIPHERAL"
 Area RW "SU.HARDW.PC.SOUND"
 Area RW "SU.HARDW.PC.VIDEO"
 Area RW "SU.HARDW.PC.VIDEO.CARD"
 Area RW "SU.HARDW.PC.VIDEO.MONITOR"
 Area RW "SU.HARDW.PC.VIDEO.RIVA"
 Area RW "SU.HARDW.SCHEMES"
 Area RW "SU.HARDW.TV.VIDEO"
 Area RW "SU.HARDW.TV.VIDEO.PROFI"
 Area RW "SU.HUMOR"
 Area RW "SU.IP.SYSOP"
 Area RW "SU.MUSIC.DRUMS"
 Area RW "SU.MUSIC.LYRICS"
 Area RW "SU.MUSIC.RAP"
 Area RW "SU.OS2"
 Area RW "SU.POL"
 Area RW "SU.SPY"
 Area RW "SU.VIRUS"
 Area RW "T-MAIL.RU"
 Area RW "TALKS.ASM"
 Area RW "XPEHOBO.MHE"
 Area RW "XSU.USELESS.FAQ"

Address 2:6033/3
 Aka 2:6033/27
 InPassword "asd"
 OutPassword "asd"
 Archiver "ZIP"
 Mode "TBOX:ALWAYSNEWBUNDLE"
 AreafixPassword "stuff"
 RobotPassword "anothershit"
 LastTrafficOut 3C470A83
 TotalTrafficOut 3241009
 TotalCountOut 811
 Area RW "$CRACK$"
 Area RW "$CRACK$.TALKS"
 Area RW "1072.COMPNEWS.TALK"
 Area RW "BRAKE'S.MAILER.SUPPORT"
 Area RW "ENET.SYSOP"
 Area RW "FAR.SUPPORT"
 Area RW "FIDONET.HISTORY"
 Area RW "GUITAR.SONGS"
 Area RW "GUITAR.SONGS.FILTERED"
 Area RW "GUITAR.SONGS.TALK"
 Area RW "HUMOR.FILTERED"
 Area RW "IV.ECHO"
 Area RW "MO.CARS.AUDIO"
 Area RW "MO.ECHO"
 Area RW "MO.JOB"
 Area RW "MO.MAKE.MONEY"
 Area RW "MO.MITINKA"
 Area RW "MO.PHRASES"
 Area RW "MO.PHYSTECH"
 Area RW "MP.LINK"
 Area RW "N5020.CRISIS"
 Area RW "N5020.FILES"
 Area RW "N5020.HUBS"
 Area RW "N5020.POINT.TALK"
 Area RW "N5020.SYSOP"
 Area RW "NICE.SOURCES"
 Area RW "POWER.LOCAL"
 Area RW "PSKOV.BAZAR"
 Area RW "PSKOV.COMP"
 Area RW "PSKOV.INTERNET"
 Area RW "PSKOV.PVT.FIDO.MARAZM"
 Area RW "PSKOV.TORMOZ"
 Area RW "PVT.CRACK"
 Area RW "PVT.EXCH.BLACK.LOG.TALK"
 Area RW "PVT.FLIRT"
 Area RW "PVT.GIRLS"
 Area RW "PVT.LAW"
 Area RW "PVT.NIICHAVO"
 Area RW "PVT.SOUND.PRO"
 Area RW "R50.COORD"
 Area RW "R50.SYSOP"
 Area RW "R50.SYSOP.INFO"
 Area RW "R50.SYSOP.TALK"
 Area RW "RAILROAD.HUMOR"
 Area RW "RAILROAD.LOCAL"
 Area RW "RAILROAD.STAT"
 Area RW "ROCKWELL.MODEM"
 Area RW "RU.ACAD"
 Area RW "RU.ALGORITHMS"
 Area RW "RU.ANECDOT"
 Area RW "RU.ANOMALIA"
 Area RW "RU.ANTI-ANTISEX"
 Area RW "RU.ANTI.ATS"
 Area RW "RU.AON"
 Area RW "RU.AUTOPILOT"
 Area RW "RU.BATTLETECH"
 Area RW "RU.BEER"
 Area RW "RU.CGI.PERL"
 Area RW "RU.CISCO"
 Area RW "RU.COMPUTER.HUMOR"
 Area RW "RU.DELPHI"
 Area RW "RU.DELPHI.DB"
 Area RW "RU.DELPHI.MASTER"
 Area RW "RU.DREAM"
 Area RW "RU.DTP"
 Area RW "RU.ECHOPROCESSORS"
 Area RW "RU.FANTASY"
 Area RW "RU.FASTUUE"
 Area RW "RU.FASTUUE.TALK"
 Area RW "RU.FIDO.INTERNET"
 Area RW "RU.FIPS"
 Area RW "RU.FOXPRO"
 Area RW "RU.GAME.RPG"
 Area RW "RU.GOLDED"
 Area RW "RU.GOLOVOLOMKA"
 Area RW "RU.HACKER"
 Area RW "RU.HIP-HOP"
 Area RW "RU.HTML.CHAINIK"
 Area RW "RU.ILLUSION"
 Area RW "RU.INTERNET"
 Area RW "RU.INTERNET.BUSINESS"
 Area RW "RU.INTERNET.CHAINIK"
 Area RW "RU.INTERNET.FILTERED"
 Area RW "RU.INTERNET.HALYAVA"
 Area RW "RU.INTERNET.SOFT"
 Area RW "RU.KMAIL"
 Area RW "RU.LINUX"
 Area RW "RU.LINUX.CHAINIK"
 Area RW "RU.LIST.CITYCAT.FIN.CBRATE"
 Area RW "RU.LIST.CITYCAT.FUNNY.CREAMFIDO"
 Area RW "RU.LIST.CITYCAT.FUNNY.GAMES.SLY"
 Area RW "RU.LIST.CITYCAT.NEWS.EZHE"
 Area RW "RU.MIXED.ALCOHOL"
 Area RW "RU.MODEM"
 Area RW "RU.MODERATOR"
 Area RW "RU.MSACCESS"
 Area RW "RU.MTV"
 Area RW "RU.MUSIC.DRUM&BASS"
 Area RW "RU.NECROMANCERS.DOS.NAVIGATOR"
 Area RW "RU.NETHACK"
 Area RW "RU.NETWORKS"
 Area RW "RU.NEWS"
 Area RW "RU.NLP"
 Area RW "RU.OS.CMP"
 Area RW "RU.PAGERS"
 Area RW "RU.PASCAL"
 Area RW "RU.PASCAL.CHAINIK"
 Area RW "RU.PASCAL.SOURCES"
 Area RW "RU.PHREAKS"
 Area RW "RU.PICKUP"
 Area RW "RU.PICKUP.GURU"
 Area RW "RU.PICTURES.PSEVDO.GRAF"
 Area RW "RU.PRIKOL"
 Area RW "RU.PSYCHOLOGY"
 Area RW "RU.RAILWAYS"
 Area RW "RU.REGINA.SUPPORT"
 Area RW "RU.SEX"
 Area RW "RU.SEX.ADV"
 Area RW "RU.SEX.ADV.TALK"
 Area RW "RU.SEX.EXCHANGE"
 Area RW "RU.SEX.PICTURES.UUE"
 Area RW "RU.SEX.SUPPORT"
 Area RW "RU.SEX.WIN95"
 Area RW "RU.SFMAIL"
 Area RW "RU.SPELLING"
 Area RW "RU.SPORT.FOOTBALL"
 Area RW "RU.SUBWAY"
 Area RW "RU.TEENAGERS"
 Area RW "RU.TOBACCO"
 Area RW "RU.UFO"
 Area RW "RU.UFO.TALKS"
 Area RW "RU.UFO.THEORY"
 Area RW "RU.UNIX.LINUX"
 Area RW "RU.USR"
 Area RW "RU.VIDEO"
 Area RW "RU.VIDEO.X_FILES"
 Area RW "RU.VP"
 Area RW "RU.WEBSITE"
 Area RW "RU.WINAMP"
 Area RW "RU.WINDOWS.2000"
 Area RW "RU.WINDOWS.NT"
 Area RW "RU.WINDOWS.NT.ADMIN"
 Area RW "RU.WINDOWS.NT.BETA"
 Area RW "RU.WINDOWS.NT.CHAINIK"
 Area RW "RU.WINDOWS.NT.FAQ"
 Area RW "SPB.ANTI.ATS"
 Area RW "SPB.FILES.MP3"
 Area RW "SPB.FREUD"
 Area RW "SPB.JOB"
 Area RW "SPB.SYSOP"
 Area RW "SPB.SYSOP.INFO"
 Area RW "SU.3DS.MAX"
 Area RW "SU.ADOBE.PHOTOSHOP"
 Area RW "SU.BOOKS"
 Area RW "SU.CHAINIK.FAQ"
 Area RW "SU.DBMS.CASE"
 Area RW "SU.DBMS.INTERBASE"
 Area RW "SU.DBMS.SQL"
 Area RW "SU.FOOTBALL.PROGNOZ"
 Area RW "SU.GAME.NEWS"
 Area RW "SU.HAMRADIO"
 Area RW "SU.HARDW"
 Area RW "SU.HARDW.AUDIO"
 Area RW "SU.HARDW.CDROM"
 Area RW "SU.HARDW.CHAINIK"
 Area RW "SU.HARDW.HDD.REPAIR"
 Area RW "SU.HARDW.OTHER"
 Area RW "SU.HARDW.PC.CPU"
 Area RW "SU.HARDW.PC.MEDIA"
 Area RW "SU.HARDW.PC.MOTHERBOARD"
 Area RW "SU.HARDW.PC.PERIPHERAL"
 Area RW "SU.HARDW.PC.SOUND"
 Area RW "SU.HARDW.PC.VIDEO"
 Area RW "SU.HARDW.PC.VIDEO.CARD"
 Area RW "SU.HARDW.PC.VIDEO.MONITOR"
 Area RW "SU.HARDW.PC.VIDEO.RIVA"
 Area RW "SU.HARDW.SCHEMES"
 Area RW "SU.HARDW.TV.VIDEO"
 Area RW "SU.HARDW.TV.VIDEO.PROFI"
 Area RW "SU.HUMOR"
 Area RW "SU.IP.SYSOP"
 Area RW "SU.KASCHENKO.LOCAL"
 Area RW "SU.MUSIC.CREATION"
 Area RW "SU.MUSIC.DRUMS"
 Area RW "SU.MUSIC.LYRICS"
 Area RW "SU.MUSIC.RAP"
 Area RW "SU.OS2"
 Area RW "SU.PASCAL.MODULA.ADA"
 Area RW "SU.POL"
 Area RW "SU.SPY"
 Area RW "SU.VIRUS"
 Area RW "T-MAIL.RU"
 Area RW "TALKS.ASM"
 Area RW "XPEHOBO.MHE"
 Area RW "XSU.USELESS.FAQ"
